ome-xml 5.2.3

Classes | Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | List of all members
ome::xml::model::Shape Class Referenceabstract

Shape model object. More...

`#include <ome/xml/model/Shape.h>`

Inheritance diagram for ome::xml::model::Shape:
[legend]
Collaboration diagram for ome::xml::model::Shape:
[legend]

## Classes
class | Impl
| Private implementation details of Shape model object. More...

## Public Member Functions
| Shape ()
| Default constructor.
| Shape (const Shape &copy)
| Copy constructor. More...
virtual | ~Shape ()
| Destructor.
bool | validElementName (const std::string &name) const
| Check if a given element name is valid for processing by this model object. More...
virtual void | update (const common::xml::dom::Element &element, ome::xml::model::OMEModel &model)
| Update the object hierarchy recursively from an XML DOM tree. More...
bool | link (ome::compat::shared_ptr< Reference > &reference, ome::compat::shared_ptr< ome::xml::model::OMEModelObject > &object)
| Link a given OME model object to this model object. More...
ome::compat::shared_ptr< std::string > | getStrokeDashArray ()
| Get the StrokeDashArray property. More...
const ome::compat::shared_ptr< std::string > | getStrokeDashArray () const
| Get the StrokeDashArray property. More...
void | setStrokeDashArray (ome::compat::shared_ptr< std::string > &strokeDashArray)
| Set the StrokeDashArray property. More...
ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength > > & | getStrokeWidth ()
| Get the StrokeWidth property. More...
const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength > > & | getStrokeWidth () const
| Get the StrokeWidth property. More...
void | setStrokeWidth (const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength > > &strokeWidth)
| Set the StrokeWidth property. More...
ome::compat::shared_ptr< bool > | getLocked ()
| Get the Locked property. More...
const ome::compat::shared_ptr< bool > | getLocked () const
| Get the Locked property. More...
void | setLocked (ome::compat::shared_ptr< bool > &locked)
| Set the Locked property. More...
ome::compat::shared_ptr< ome::xml::model::enums::FillRule > | getFillRule ()
| Get the FillRule property. More...
const ome::compat::shared_ptr< ome::xml::model::enums::FillRule > | getFillRule () const
| Get the FillRule property. More...
void | setFillRule (ome::compat::shared_ptr< ome::xml::model::enums::FillRule > &fillRule)
| Set the FillRule property. More...
ome::compat::shared_ptr< std::string > | getText ()
| Get the Text property. More...
const ome::compat::shared_ptr< std::string > | getText () const
| Get the Text property. More...
void | setText (ome::compat::shared_ptr< std::string > &text)
| Set the Text property. More...
ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > | getTheC ()
| Get the TheC property. More...
const ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > | getTheC () const
| Get the TheC property. More...
void | setTheC (ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > &theC)
| Set the TheC property. More...
ome::compat::shared_ptr< ome::xml::model::enums::FontFamily > | getFontFamily ()
| Get the FontFamily property. More...
const ome::compat::shared_ptr< ome::xml::model::enums::FontFamily > | getFontFamily () const
| Get the FontFamily property. More...
void | setFontFamily (ome::compat::shared_ptr< ome::xml::model::enums::FontFamily > &fontFamily)
| Set the FontFamily property. More...
ome::compat::shared_ptr< ome::xml::model::enums::FontStyle > | getFontStyle ()
| Get the FontStyle property. More...
const ome::compat::shared_ptr< ome::xml::model::enums::FontStyle > | getFontStyle () const
| Get the FontStyle property. More...
void | setFontStyle (ome::compat::shared_ptr< ome::xml::model::enums::FontStyle > &fontStyle)
| Set the FontStyle property. More...
ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::NonNegativeInteger > > & | getFontSize ()
| Get the FontSize property. More...
const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::NonNegativeInteger > > & | getFontSize () const
| Get the FontSize property. More...
void | setFontSize (const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::NonNegativeInteger > > &fontSize)
| Set the FontSize property. More...
ome::compat::shared_ptr< ome::xml::model::primitives::Color > | getFillColor ()
| Get the FillColor property. More...
const ome::compat::shared_ptr< ome::xml::model::primitives::Color > | getFillColor () const
| Get the FillColor property. More...
void | setFillColor (ome::compat::shared_ptr< ome::xml::model::primitives::Color > &fillColor)
| Set the FillColor property. More...
ome::compat::shared_ptr< ome::xml::model::primitives::Color > | getStrokeColor ()
| Get the StrokeColor property. More...
const ome::compat::shared_ptr< ome::xml::model::primitives::Color > | getStrokeColor () const
| Get the StrokeColor property. More...
void | setStrokeColor (ome::compat::shared_ptr< ome::xml::model::primitives::Color > &strokeColor)
| Set the StrokeColor property. More...
ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > | getTheT ()
| Get the TheT property. More...
const ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > | getTheT () const
| Get the TheT property. More...
void | setTheT (ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > &theT)
| Set the TheT property. More...
const std::string & | getID () const
| Get the ID property. More...
void | setID (const std::string &id)
| Set the ID property. More...
ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > | getTheZ ()
| Get the TheZ property. More...
const ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > | getTheZ () const
| Get the TheZ property. More...
void | setTheZ (ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > &theZ)
| Set the TheZ property. More...
ome::compat::shared_ptr< ome::xml::model::AffineTransform > | getTransform ()
| Get the Transform property. More...
const ome::compat::shared_ptr< ome::xml::model::AffineTransform > | getTransform () const
| Get the Transform property. More...
void | setTransform (ome::compat::shared_ptr< ome::xml::model::AffineTransform > &transform)
| Set the Transform property. More...
OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type::size_type | sizeOfLinkedAnnotationList () const
| Get size of linked Annotation list. More...
OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type | getLinkedAnnotationList () const
| Get the linked Annotation list. More...
const ome::compat::weak_ptr< ome::xml::model::Annotation > & | getLinkedAnnotation (OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type::size_type index) const
| Get linked Annotation. More...
const ome::compat::weak_ptr< ome::xml::model::Annotation > & | setLinkedAnnotation (OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type::size_type index, const ome::compat::shared_ptr< ome::xml::model::Annotation > &annotation)
| Set linked Annotation. More...
bool | linkAnnotation (const ome::compat::shared_ptr< ome::xml::model::Annotation > &annotation)
| Link Annotation. More...
bool | unlinkAnnotation (const ome::compat::shared_ptr< ome::xml::model::Annotation > &annotation)
| Unlink Annotation. More...
ome::compat::weak_ptr< ome::xml::model::Union > | getUnion ()
| Get the Union property. More...
const ome::compat::weak_ptr< ome::xml::model::Union > | getUnion () const
| Get the Union property. More...
void | setUnion (ome::compat::weak_ptr< ome::xml::model::Union > &union_BackReference)
| Set the Union property. More...
virtual const std::string & | getShapeType () const =0
| Get the Shape type. More...
virtual common::xml::dom::Element | asXMLElement (common::xml::dom::Document &document) const
| Transform the object hierarchy rooted at this element to XML. More...
const std::string & | getXMLNamespace () const
| Get the XML namespace for this model object. More...
Public Member Functions inherited from ome::xml::model::detail::OMEModelObject
virtual | ~OMEModelObject ()
| Destructor.
virtual void | update (const common::xml::dom::Element &element, ::ome::xml::model::OMEModel &model)
| Update the object hierarchy recursively from an XML DOM tree. More...
virtual bool | link (ome::compat::shared_ptr< Reference > &reference, ome::compat::shared_ptr< ::ome::xml::model::OMEModelObject > &object)
| Link a given OME model object to this model object. More...
Public Member Functions inherited from ome::xml::model::OMEModelObject
virtual const std::string & | elementName () const =0
| Get the element name of this model object. More...
virtual bool | link (ome::compat::shared_ptr< Reference > &reference, ome::compat::shared_ptr< OMEModelObject > &object)=0
| Link a given OME model object to this model object. More...

## Protected Member Functions
virtual common::xml::dom::Element | asXMLElementInternal (common::xml::dom::Document &document, common::xml::dom::Element &element) const
| Transform the object hierarchy rooted at this element to XML. More...
Protected Member Functions inherited from ome::xml::model::detail::OMEModelObject
| OMEModelObject (const std::string &objectType="OMEModelObject")
| Constructor.
| OMEModelObject (const OMEModelObject &copy)
| Copy constructor. More...
template<class C , typename T >
bool | contains (const C &container, const ome::compat::shared_ptr< T > &element)
| Check if a container contains a particular element. More...
Protected Member Functions inherited from ome::xml::model::OMEModelObject
| OMEModelObject ()
| Constructor.

## Private Member Functions
Shape & | operator= (const Shape &)
| Assignment operator (deleted).

## Private Attributes
ome::compat::shared_ptr< Impl > | impl
| Private implementation details.

## Additional Inherited Members
Static Public Member Functions inherited from ome::xml::model::detail::OMEModelObject
static std::vector< common::xml::dom::Element > | getChildrenByTagName (const common::xml::dom::Element &parent, const std::string &name)
| Retrieve all the children of an element that have a given tag name. More...
static std::string | stripNamespacePrefix (const std::string &value)
| Strip the namespace prefix from a tag name. More...
Protected Attributes inherited from ome::xml::model::detail::OMEModelObject
ome::common::Logger | logger
| Message logger.

## Detailed Description

Shape model object.

## Constructor & Destructor Documentation

## § Shape()

ome::xml::model::Shape::Shape | ( | const Shape & | copy | ) |

Copy constructor.

Parameters

  copy | the Shape to copy.

## Member Function Documentation

## § asXMLElement()

common::xml::dom::Element ome::xml::model::Shape::asXMLElement | ( | common::xml::dom::Document & | document | ) | const
| virtual

Transform the object hierarchy rooted at this element to XML.

Parameters

  document | document for element creation

Returns
  an XML DOM tree root element for this model object.

Implements ome::xml::model::OMEModelObject.

Reimplemented in ome::xml::model::Line, ome::xml::model::Mask, ome::xml::model::Polyline, ome::xml::model::Ellipse, ome::xml::model::Rectangle, ome::xml::model::Label, ome::xml::model::Point, and ome::xml::model::Polygon.

References asXMLElementInternal(), ome::common::xml::dom::Document::createElementNS(), and getXMLNamespace().

## § asXMLElementInternal()

common::xml::dom::Element ome::xml::model::Shape::asXMLElementInternal | ( | common::xml::dom::Document & | document,
|  | common::xml::dom::Element & | element
| ) |  | const
| protectedvirtual

Transform the object hierarchy rooted at this element to XML.

This internal implementation of asXMLelement also requires an XML element, which must not be null, or may be instantiated and passed from superclasses.

Parameters

  document | XML document for element creation.
  element | XML element for setting model data.

Returns
  an XML DOM tree root element for this model object.

Implements ome::xml::model::detail::OMEModelObject.

Reimplemented in ome::xml::model::Line, ome::xml::model::Mask, ome::xml::model::Polyline, ome::xml::model::Ellipse, ome::xml::model::Rectangle, ome::xml::model::Label, ome::xml::model::Point, and ome::xml::model::Polygon.

References ome::common::xml::dom::Node::appendChild(), ome::xml::model::detail::OMEModelObject::asXMLElementInternal(), ome::common::xml::dom::Document::createElementNS(), getXMLNamespace(), impl, and ome::common::xml::dom::Element::setAttribute().

Referenced by asXMLElement(), ome::xml::model::Polygon::asXMLElementInternal(), ome::xml::model::Point::asXMLElementInternal(), ome::xml::model::Label::asXMLElementInternal(), ome::xml::model::Rectangle::asXMLElementInternal(), ome::xml::model::Ellipse::asXMLElementInternal(), ome::xml::model::Polyline::asXMLElementInternal(), ome::xml::model::Mask::asXMLElementInternal(), and ome::xml::model::Line::asXMLElementInternal().

Here is the caller graph for this function:

## § getFillColor() [1/2]

ome::compat::shared_ptr< ome::xml::model::primitives::Color > ome::xml::model::Shape::getFillColor | ( |  | ) |

Get the FillColor property.

Returns
  the FillColor property.

References impl.

## § getFillColor() [2/2]

const ome::compat::shared_ptr< ome::xml::model::primitives::Color > ome::xml::model::Shape::getFillColor | ( |  | ) | const

Get the FillColor property.

Returns
  the FillColor property.

References impl.

## § getFillRule() [1/2]

ome::compat::shared_ptr< ome::xml::model::enums::FillRule > ome::xml::model::Shape::getFillRule | ( |  | ) |

Get the FillRule property.

Returns
  the FillRule property.

References impl.

## § getFillRule() [2/2]

const ome::compat::shared_ptr< ome::xml::model::enums::FillRule > ome::xml::model::Shape::getFillRule | ( |  | ) | const

Get the FillRule property.

Returns
  the FillRule property.

References impl.

## § getFontFamily() [1/2]

ome::compat::shared_ptr< ome::xml::model::enums::FontFamily > ome::xml::model::Shape::getFontFamily | ( |  | ) |

Get the FontFamily property.

Returns
  the FontFamily property.

References impl.

## § getFontFamily() [2/2]

const ome::compat::shared_ptr< ome::xml::model::enums::FontFamily > ome::xml::model::Shape::getFontFamily | ( |  | ) | const

Get the FontFamily property.

Returns
  the FontFamily property.

References impl.

## § getFontSize() [1/2]

ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::NonNegativeInteger > > & ome::xml::model::Shape::getFontSize | ( |  | ) |

Get the FontSize property.

Returns
  the FontSize property.

References impl.

## § getFontSize() [2/2]

const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::NonNegativeInteger > > & ome::xml::model::Shape::getFontSize | ( |  | ) | const

Get the FontSize property.

Returns
  the FontSize property.

References impl.

## § getFontStyle() [1/2]

ome::compat::shared_ptr< ome::xml::model::enums::FontStyle > ome::xml::model::Shape::getFontStyle | ( |  | ) |

Get the FontStyle property.

Returns
  the FontStyle property.

References impl.

## § getFontStyle() [2/2]

const ome::compat::shared_ptr< ome::xml::model::enums::FontStyle > ome::xml::model::Shape::getFontStyle | ( |  | ) | const

Get the FontStyle property.

Returns
  the FontStyle property.

References impl.

## § getID()

const std::string & ome::xml::model::Shape::getID | ( |  | ) | const

Get the ID property.

Returns
  the ID property.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § getLinkedAnnotation()

const ome::compat::weak_ptr< ome::xml::model::Annotation > & ome::xml::model::Shape::getLinkedAnnotation | ( | OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type::size_type | index | ) | const

Get linked Annotation.

Parameters

  index | the index number of the Annotation.

Returns
  a weak pointer to the Annotation.

Exceptions

  std::out_of_range | if the index is invalid.

References impl.

## § getLinkedAnnotationList()

OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type ome::xml::model::Shape::getLinkedAnnotationList | ( |  | ) | const

Get the linked Annotation list.

Returns
  a reference to the list.

References impl.

## § getLocked() [1/2]

ome::compat::shared_ptr< bool > ome::xml::model::Shape::getLocked | ( |  | ) |

Get the Locked property.

Returns
  the Locked property.

References impl.

## § getLocked() [2/2]

const ome::compat::shared_ptr< bool > ome::xml::model::Shape::getLocked | ( |  | ) | const

Get the Locked property.

Returns
  the Locked property.

References impl.

## § getShapeType()

virtual const std::string& ome::xml::model::Shape::getShapeType | ( |  | ) | const
| pure virtual

Get the Shape type.

Returns
  the concrete type of the Shape.

Implemented in ome::xml::model::Line, ome::xml::model::Mask, ome::xml::model::Polyline, ome::xml::model::Ellipse, ome::xml::model::Rectangle, ome::xml::model::Label, ome::xml::model::Point, and ome::xml::model::Polygon.

## § getStrokeColor() [1/2]

ome::compat::shared_ptr< ome::xml::model::primitives::Color > ome::xml::model::Shape::getStrokeColor | ( |  | ) |

Get the StrokeColor property.

Returns
  the StrokeColor property.

References impl.

## § getStrokeColor() [2/2]

const ome::compat::shared_ptr< ome::xml::model::primitives::Color > ome::xml::model::Shape::getStrokeColor | ( |  | ) | const

Get the StrokeColor property.

Returns
  the StrokeColor property.

References impl.

## § getStrokeDashArray() [1/2]

ome::compat::shared_ptr< std::string > ome::xml::model::Shape::getStrokeDashArray | ( |  | ) |

Get the StrokeDashArray property.

Returns
  the StrokeDashArray property.

References impl.

## § getStrokeDashArray() [2/2]

const ome::compat::shared_ptr< std::string > ome::xml::model::Shape::getStrokeDashArray | ( |  | ) | const

Get the StrokeDashArray property.

Returns
  the StrokeDashArray property.

References impl.

## § getStrokeWidth() [1/2]

ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength > > & ome::xml::model::Shape::getStrokeWidth | ( |  | ) |

Get the StrokeWidth property.

Returns
  the StrokeWidth property.

References impl.

## § getStrokeWidth() [2/2]

const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength > > & ome::xml::model::Shape::getStrokeWidth | ( |  | ) | const

Get the StrokeWidth property.

Returns
  the StrokeWidth property.

References impl.

## § getText() [1/2]

ome::compat::shared_ptr< std::string > ome::xml::model::Shape::getText | ( |  | ) |

Get the Text property.

Returns
  the Text property.

References impl.

## § getText() [2/2]

const ome::compat::shared_ptr< std::string > ome::xml::model::Shape::getText | ( |  | ) | const

Get the Text property.

Returns
  the Text property.

References impl.

## § getTheC() [1/2]

ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > ome::xml::model::Shape::getTheC | ( |  | ) |

Get the TheC property.

Returns
  the TheC property.

References impl.

## § getTheC() [2/2]

const ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > ome::xml::model::Shape::getTheC | ( |  | ) | const

Get the TheC property.

Returns
  the TheC property.

References impl.

## § getTheT() [1/2]

ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > ome::xml::model::Shape::getTheT | ( |  | ) |

Get the TheT property.

Returns
  the TheT property.

References impl.

## § getTheT() [2/2]

const ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > ome::xml::model::Shape::getTheT | ( |  | ) | const

Get the TheT property.

Returns
  the TheT property.

References impl.

## § getTheZ() [1/2]

ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > ome::xml::model::Shape::getTheZ | ( |  | ) |

Get the TheZ property.

Returns
  the TheZ property.

References impl.

## § getTheZ() [2/2]

const ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > ome::xml::model::Shape::getTheZ | ( |  | ) | const

Get the TheZ property.

Returns
  the TheZ property.

References impl.

## § getTransform() [1/2]

ome::compat::shared_ptr< ome::xml::model::AffineTransform > ome::xml::model::Shape::getTransform | ( |  | ) |

Get the Transform property.

Returns
  the Transform property.

References impl.

## § getTransform() [2/2]

const ome::compat::shared_ptr< ome::xml::model::AffineTransform > ome::xml::model::Shape::getTransform | ( |  | ) | const

Get the Transform property.

Returns
  the Transform property.

References impl.

## § getUnion() [1/2]

ome::compat::weak_ptr< ome::xml::model::Union > ome::xml::model::Shape::getUnion | ( |  | ) |

Get the Union property.

Returns
  the Union property.

References impl.

## § getUnion() [2/2]

const ome::compat::weak_ptr< ome::xml::model::Union > ome::xml::model::Shape::getUnion | ( |  | ) | const

Get the Union property.

Returns
  the Union property.

References impl.

## § getXMLNamespace()

const std::string & ome::xml::model::Shape::getXMLNamespace | ( |  | ) | const
| virtual

Get the XML namespace for this model object.

Returns
  the XML namespace.

Implements ome::xml::model::OMEModelObject.

Referenced by asXMLElement(), and asXMLElementInternal().

Here is the caller graph for this function:

## § link()

bool ome::xml::model::Shape::link | ( | ome::compat::shared_ptr< Reference > & | reference,
|  | ome::compat::shared_ptr< ome::xml::model::OMEModelObject > & | object
| ) |  |

Link a given OME model object to this model object.

Parameters

  reference | type qualifier for the reference. This should be the corresponding reference type for object. If, for example, object is of type Image, reference must be of type ImageRef.
  object | Model object to link to.

Returns
  `true` if this model object was able to handle the reference, otherwise `false`.

Todo:
  the use of reference to provide type information for the type of object is unconventional and quite possibly unnecessary–a simple string or type_info would suffice for what it's being used for, if it's needed at all. Is this true for all cases? The implementation also needs to do strict checking of the object type; it's not currently failing if it's of the wrong type. This applies to all generated model objects implementing this interface.

Todo:
  This bit is silly; why do we have two dynamic_casts here.

References impl, ome::xml::model::detail::OMEModelObject::link(), ome::xml::model::Annotation::linkShape(), and ome::xml::model::detail::OMEModelObject::logger.

Referenced by ome::xml::model::Ellipse::link(), ome::xml::model::Label::link(), ome::xml::model::Rectangle::link(), ome::xml::model::Point::link(), ome::xml::model::Polygon::link(), ome::xml::model::Mask::link(), ome::xml::model::Polyline::link(), and ome::xml::model::Line::link().

Here is the caller graph for this function:

## § linkAnnotation()

bool ome::xml::model::Shape::linkAnnotation | ( | const ome::compat::shared_ptr< ome::xml::model::Annotation > & | annotation | ) |

Link Annotation.

Parameters

  annotation | the Annotation to link.

Returns
  `true` if the object was added to the internal annotationLinks list, otherwise `false`.

Todo:
  Why have a return value here; what is it used for? Is this an artifact of the Java API?

References impl.

## § setFillColor()

void ome::xml::model::Shape::setFillColor | ( | ome::compat::shared_ptr< ome::xml::model::primitives::Color > & | fillColor | ) |

Set the FillColor property.

Parameters

  fillColor | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setFillRule()

void ome::xml::model::Shape::setFillRule | ( | ome::compat::shared_ptr< ome::xml::model::enums::FillRule > & | fillRule | ) |

Set the FillRule property.

Parameters

  fillRule | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setFontFamily()

void ome::xml::model::Shape::setFontFamily | ( | ome::compat::shared_ptr< ome::xml::model::enums::FontFamily > & | fontFamily | ) |

Set the FontFamily property.

Parameters

  fontFamily | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setFontSize()

void ome::xml::model::Shape::setFontSize | ( | const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::NonNegativeInteger > > & | fontSize | ) |

Set the FontSize property.

Parameters

  fontSize | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setFontStyle()

void ome::xml::model::Shape::setFontStyle | ( | ome::compat::shared_ptr< ome::xml::model::enums::FontStyle > & | fontStyle | ) |

Set the FontStyle property.

Parameters

  fontStyle | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setID()

void ome::xml::model::Shape::setID | ( | const std::string & | id | ) |

Set the ID property.

Parameters

  id | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setLinkedAnnotation()

const ome::compat::weak_ptr< ome::xml::model::Annotation > & ome::xml::model::Shape::setLinkedAnnotation | ( | OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type::size_type | index,
|  | const ome::compat::shared_ptr< ome::xml::model::Annotation > & | annotation
| ) |  |

Set linked Annotation.

Note
  The index must be valid.

Parameters

  index | the index number of the Annotation.
  annotation | the Annotation to set.

Returns
  a weak pointer to the Annotation.

Exceptions

  std::out_of_range | if the index is invalid.

References impl.

## § setLocked()

void ome::xml::model::Shape::setLocked | ( | ome::compat::shared_ptr< bool > & | locked | ) |

Set the Locked property.

Parameters

  locked | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setStrokeColor()

void ome::xml::model::Shape::setStrokeColor | ( | ome::compat::shared_ptr< ome::xml::model::primitives::Color > & | strokeColor | ) |

Set the StrokeColor property.

Parameters

  strokeColor | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setStrokeDashArray()

void ome::xml::model::Shape::setStrokeDashArray | ( | ome::compat::shared_ptr< std::string > & | strokeDashArray | ) |

Set the StrokeDashArray property.

Parameters

  strokeDashArray | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setStrokeWidth()

void ome::xml::model::Shape::setStrokeWidth | ( | const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength > > & | strokeWidth | ) |

Set the StrokeWidth property.

Parameters

  strokeWidth | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setText()

void ome::xml::model::Shape::setText | ( | ome::compat::shared_ptr< std::string > & | text | ) |

Set the Text property.

Parameters

  text | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setTheC()

void ome::xml::model::Shape::setTheC | ( | ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > & | theC | ) |

Set the TheC property.

Parameters

  theC | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setTheT()

void ome::xml::model::Shape::setTheT | ( | ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > & | theT | ) |

Set the TheT property.

Parameters

  theT | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setTheZ()

void ome::xml::model::Shape::setTheZ | ( | ome::compat::shared_ptr< ome::xml::model::primitives::NonNegativeInteger > & | theZ | ) |

Set the TheZ property.

Parameters

  theZ | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setTransform()

void ome::xml::model::Shape::setTransform | ( | ome::compat::shared_ptr< ome::xml::model::AffineTransform > & | transform | ) |

Set the Transform property.

Parameters

  transform | the value to set.

References impl, and ome::xml::transform().

## § setUnion()

void ome::xml::model::Shape::setUnion | ( | ome::compat::weak_ptr< ome::xml::model::Union > & | union_BackReference | ) |

Set the Union property.

Parameters

  union_BackReference | the value to set.

References impl.

## § sizeOfLinkedAnnotationList()

OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type::size_type ome::xml::model::Shape::sizeOfLinkedAnnotationList | ( |  | ) | const

Get size of linked Annotation list.

Returns
  the size of the list.

References impl.

## § unlinkAnnotation()

bool ome::xml::model::Shape::unlinkAnnotation | ( | const ome::compat::shared_ptr< ome::xml::model::Annotation > & | annotation | ) |

Unlink Annotation.

Parameters

  annotation | the Annotation to unlink.

Returns
  `true` if the Annotation was unlinked, otherwise `false` if the Annotation was not linked and could hence not be unlinked.

Todo:

  Does the return value serve any useful purpose? Is this also inherited Java API?

  Doesn't the removal break the indexing?

  Does the removal deal with multiple instances; we aren't preventing duplicates on insertion.

References impl.

## § update()

void ome::xml::model::Shape::update | ( | const common::xml::dom::Element & | element,
|  | ome::xml::model::OMEModel & | model
| ) |  |
| virtual

Update the object hierarchy recursively from an XML DOM tree.

Note
  No properties are removed, only added or updated.

Parameters

  element | root of the XML DOM tree to from which to construct the model object graph.
  model | handler for the OME model used to track instances and references seen during the update.

Exceptions

  EnumerationException | if there is an error instantiating an enumeration during model object creation, or ModelException if there are any consistency or validity errors found during processing.

Implements ome::xml::model::OMEModelObject.

Reimplemented in ome::xml::model::Line, ome::xml::model::Mask, ome::xml::model::Polyline, ome::xml::model::Ellipse, ome::xml::model::Label, ome::xml::model::Point, ome::xml::model::Polygon, and ome::xml::model::Rectangle.

References ome::xml::model::OMEModel::addModelObject(), ome::xml::model::OMEModel::addReference(), ome::common::xml::dom::Element::getAttribute(), ome::xml::model::detail::OMEModelObject::getChildrenByTagName(), getID(), ome::common::xml::dom::Element::getTagName(), ome::common::xml::dom::Element::hasAttribute(), ome::xml::model::detail::OMEModelObject::logger, setFillColor(), setFillRule(), setFontFamily(), setFontSize(), setFontStyle(), setID(), setLocked(), setStrokeColor(), setStrokeDashArray(), setStrokeWidth(), setText(), setTheC(), setTheT(), setTheZ(), ome::xml::model::detail::OMEModelObject::stripNamespacePrefix(), ome::xml::model::detail::OMEModelObject::update(), and validElementName().

Referenced by ome::xml::model::Ellipse::update(), ome::xml::model::Label::update(), ome::xml::model::Rectangle::update(), ome::xml::model::Point::update(), ome::xml::model::Polygon::update(), ome::xml::model::Mask::update(), ome::xml::model::Polyline::update(), and ome::xml::model::Line::update().

Here is the caller graph for this function:

## § validElementName()

bool ome::xml::model::Shape::validElementName | ( | const std::string & | name | ) | const
| virtual

Check if a given element name is valid for processing by this model object.

Used for processing nodes when interitance is involved.

Parameters

  name | the element name to check.

Returns
  `true` if valid, `false` if invalid.

Implements ome::xml::model::detail::OMEModelObject.

References ome::xml::model::detail::OMEModelObject::validElementName().

Referenced by update(), ome::xml::model::Rectangle::validElementName(), ome::xml::model::Ellipse::validElementName(), ome::xml::model::Label::validElementName(), ome::xml::model::Point::validElementName(), ome::xml::model::Polygon::validElementName(), ome::xml::model::Mask::validElementName(), ome::xml::model::Polyline::validElementName(), and ome::xml::model::Line::validElementName().

Here is the caller graph for this function:

The documentation for this class was generated from the following files:

- ome/xml/model/Shape.h
- ome/xml/model/Shape.cpp